Option Explicit
On Error Resume Next

Dim strImagePath1, strImagePath2, strImagePath3, strImagePath4, strImagePath5, resultFile
strImagePath1 = "C:\test\image_src"
strImagePath2 = "C:\test\image_dest"
strImagePath3 = "image"
strImagePath4 = "imageL"
strImagePath5 = "imageR"
resultFile    = "result.html"

main()

Sub main()
  WScript.Echo "START ..."

  makeImageFolder strImagePath3
  makeImageFolder strImagePath4
  makeImageFolder strImagePath5

  Call copyImages(strImagePath1, strImagePath4)
  Call copyImages(strImagePath2, strImagePath5)

  writeResultHeader()
  outputChanges()
  writeResultFooter()

  WScript.Echo "... END"
End Sub

Sub makeImageFolder(strDirname)
  Dim objWshShell
  Dim objExec
  Dim strCmd

  strCmd = "cmd.exe /c md " & strDirname

  Set objWshShell = WScript.CreateObject("WScript.Shell")
  Set objExec = objWshShell.Exec(strCmd)

  Do While objExec.Status = 0
    WScript.Sleep 100
  Loop

  Set objWshShell = Nothing
  Set objExec = Nothing

  WScript.Echo "Created dir: " & strDirname
End Sub

Sub copyImages(strSrc, strDest)
  Dim objWshShell
  Dim objExec
  Dim strCmd

  strCmd = "cmd.exe /c xcopy /E /C " & strSrc & " " & strDest

  Set objWshShell = WScript.CreateObject("WScript.Shell")
  Set objExec = objWshShell.Exec(StrCmd)

  Set objWshShell = Nothing
  Set objExec = Nothing

  WScript.Echo "Copy images " & strSrc & " to " & strDest
End Sub

Sub outputChanges()
  Dim objWshShell
  Dim fso, folder, file, subFolder
  Dim objFSO
  Dim objFile

  Set fso = WScript.CreateObject("Scripting.FileSystemObject")
  Set folder = fso.GetFolder(strImagePath2)

  Set objWshShell = WScript.CreateObject("WScript.Shell")
  Dim objExec
  Dim strCmd
  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
  Set objFile = objFSO.OpenTextFile(resultFile, 8, True)

  For Each file In folder.Files
    WScript.Echo file.Name
    strCmd = "cmd.exe /c composite.exe -compose difference "
    strCmd = strCmd & strImagePath1 & "\" & file.Name & " "
    strCmd = strCmd & strImagePath2 & "\" & file.Name & " "
    strCmd = strCmd & strImagePath3 & "\diff-" & file.Name

    Set objExec = objWshShell.Exec(strCmd)

    Do While objExec.Status = 0
      WScript.Sleep 100
    Loop

    strCmd = "cmd.exe /c identify.exe -format ""%[mean]"" " & strImagePath3 & "\diff-" & file.Name
    Set objExec = objWshShell.Exec(strCmd)

    Do While objExec.Status = 0
        WScript.Sleep 100
    Loop

    Dim strRtn, dblImg, dblPercent
    strRtn = objExec.StdOut.ReadLine

    If IsNumeric(strRtn) Then
      dblImg = Round(100.0 - ((CDbl(strRtn) * 100.0) / 65535.0) - 0.005, 2)
    Else
      dblImg = 0
    End If

    If strRtn = "0" Then
      objFile.WriteLine("<tr class=""status_done"" style=""cursor: pointer;"">")
      objFile.WriteLine("    <td>diff-" & file.Name & "</td>")
      objFile.WriteLine("    <td><a href=""" & strImagePath4 & "/" & file.Name & """>L</a></td>")
      objFile.WriteLine("    <td><a href=""" & strImagePath5 & "/" & file.Name & """>R</a></td>")
      objFile.WriteLine("    <td>Same</td>")
      objFile.WriteLine("    <td>100.0</td>")
      objFile.WriteLine("</tr>")
    Else
      objFile.WriteLine("<tr class=""status_failed"" style=""cursor: pointer;"">")
      objFile.WriteLine("    <td>diff-" & file.Name & "</td>")
      objFile.WriteLine("    <td><a href=""" & strImagePath4 & "/" & file.Name & """>L</a></td>")
      objFile.WriteLine("    <td><a href=""" & strImagePath5 & "/" & file.Name & """>R</a></td>")
      objFile.WriteLine("    <td><a href=""" & strImagePath3 & "/diff-" & file.Name & """>Difference</a></td>")
      objFile.WriteLine("    <td>" & dblImg & "</td>")
      objFile.WriteLine("</tr>")
    End If

    Set objExec = Nothing
  Next

  objFile.Close
  Set objFile = Nothing
  Set objFSO = Nothing

End Sub

Sub writeResultHeader() 
  Dim objFSO
  Dim objFile

  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")

  Set objFile = objFSO.OpenTextFile(resultFile, 2, True)
  objFile.WriteLine("<html><head>")
  objFile.WriteLine("<meta http-equiv=""content-type"" content=""text/html; charset=UTF-8"">")
  objFile.WriteLine("<style type=""text/css"">")
  objFile.WriteLine("body, table {font-family: Verdana, Arial, sans-serif; font-size: 12;}")
  objFile.WriteLine("table {border-collapse: collapse; border: 1px solid #ccc;}")
  objFile.WriteLine("th, td {padding-left: 0.3em; padding-right: 0.3em;}")
  objFile.WriteLine("a {text-decoration: none;}")
  objFile.WriteLine(".title {font-style: italic;}")
  objFile.WriteLine(".selected {background-color: #ffffcc;}")
  objFile.WriteLine(".status_done {background-color: #eeffee;}")
  objFile.WriteLine(".status_passed {background-color: #ccffcc;}")
  objFile.WriteLine(".status_failed {background-color: #ffcccc;}")
  objFile.WriteLine(".breakpoint {background-color: #cccccc; border: 1px solid black;}")
  objFile.WriteLine("</style><title>Test suite results</title></head><body>")
  objFile.WriteLine("<h1>Test suite results </h1>")
  objFile.WriteLine("<table border=""1"" cellpadding=""1"" cellspacing=""1"">")
  objFile.WriteLine("<thead>")
  objFile.WriteLine("<tr class=""title status_passed""><td rowspan=""1"" colspan=""5"">image-diff</td></tr>")
  objFile.WriteLine("</thead><tbody>")
  objFile.Close

End Sub

Sub writeResultFooter() 
  Dim objFSO
  Dim objFile

  Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")

  Set objFile = objFSO.OpenTextFile(resultFile, 8, True)
  objFile.WriteLine("</tbody></table>")
      objFile.WriteLine("</body></html>")
  objFile.Close
End Sub
